/*
** ADM-XRC Series Driver
**
** (C) Copyright 2006 Alpha Data
**
** lbrst.c - IOCTL handlers for performing local bus reset.
**
** ----------------------------------------------------------------------------
*/

#include "device.h"
#include "ioctls.h"
#include "methods.h"
#include "lbrst.h"

OS_STATUS
ADMXRC_LocalBusReset(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq)
{
  OS_STATUS status = OS_STATUS_SUCCESS;
  MethodResult result;

  result = pDevCtx->methods.localBusReset(pDevCtx, TRUE);
  if (result != MethodResult_Success) {
    switch (result) {
    case MethodResult_NotSupported:
      status = OS_MAKE_STATUS(ADMXRC2_NOT_SUPPORTED);
      break;
    default:
      status = OS_MAKE_STATUS(ADMXRC2_UNKNOWN_ERROR);
      break;
    }
    return status;
  }
  os_delay_busy_us(10);
  pDevCtx->methods.localBusReset(pDevCtx, FALSE);
  os_delay_busy_us(10);

  return status;
}
